// 45822035EE_02
// ---------------------
/*/////////////////////////////////////////////////////////////////////////////////////////////////
	User Guide
		Search JavaScript
 Modified : 2014-09-07
/////////////////////////////////////////////////////////////////////////////////////////////////*/

var Searching = (function(){
	
	var settings = {
		"maxItemOfPage": 10 // 1ページあたりの結果数
		,"pageNaviMax": 7 // ページインクリメントの最大
		,"snippetStart": 10 // ヒットキーワードの前何文字表示
		,"snippetLength": 25 // 説明の表示文字数
		,"searchType": 'and' // 検索タイプ(and|or)
		,"index": data //別ファイルのインデックスの変数名
		,"keywordData": keyword_data
		,"srCountType": srCountType
		,"st": "count"
		,"re": "result"
		,"nv": "navi"
		,"startTime": new Date().getTime()
		,"datalist": []
		,"datalistTit": []
		,"bolderlist": []
		,"releatekey": []
		,"page": 1
		,"charUpLo": "" //大文字小文字区別[ する："" | しない："i" ]
		,"ZenHan": false
		,"lastQuery": ""
		,"entity": [
			["&",["&amp;","&#38;"]]//二重変換抑制のため'&'を先頭に配置
			,[" ", ["&nbsp;","&#160;"]]
			,["<",["&lt;","&#60;"]]
			,[">",["&gt;","&#62;"]]
			,['"',["&quot;","&#34;"]]
			,["'",["&apos;","&#39;"]]
		]
		,"omi":'<span class="conm">&#8230;</span>'
	}; 
	settings.andSearch = settings.searchType === 'and';
	var searchTime, serchRe, temp='';
	
	var __self = {
		
		"_init": function(){
			
			$('#searchSubmit').after('<span id="searchBtn"></span>');
			settings.searchURI = searchAction($('form#search').attr('action'));
			
			//オートコンプリート
			__self._autocomplete('#searchKey');
			
			//ページネーション値取得
			settings.page = get['p'] || 1 ;
			
			//オプション取得設定
			var opt = $('fieldset.option input');
			var option=[];
			get['op'] = get['op']||'';
			for(var i=0,len=opt.length; i<len; i++){
				if( (!!get['op']) && (get['op'].match(opt.eq(i).attr('id')))){
					opt.eq(i).attr('checked','checked');
					option[opt.eq(i).attr('id')] = true;
				}
			}
			settings.charUpLo = (option['op1'])? "" : "i";
			settings.ZenHan = option['op2'] || false;
			
			//イベント
			__self._event();
			
			// 検索命令 ////////////////////////////
			var getKey = (get['k']) ? $.trim( get['k'].replace(/[\s　]+/g," ") ) : false;
			if(getKey && getKey != settings.lastQuery){
				$("#searchKey").val(getKey).addClass("keyIn");
				settings.lastQuery = getKey;
				__self._setIndex();
				var re = __self._find(getKey);
				serchRe = re;
				__self._pagenavi(re);
				__self._view(re, settings.page);
			}
			///////////////////////////////
			
			__self._windowSizing();
			
		}
		
		
		/* ***********************************
		 * インデックス取得
		 */
		,"_setIndex": function(){
			var body, title, len = settings.index.length;
			for(var i=0; i<len; i++){
				body = title = '';
				body = __self._entityReplace( __self._ufrm(settings.index[i].Body) );
				title = __self._entityReplace( __self._ufrm(settings.index[i].Title) );
				settings.datalist.push( body + "　" + title );
				settings.datalistTit.push( title );
			}
		}
		
		
		/* ***********************************
		 * エンティティ置換
		 */
		,"_entityReplace": function(str, type){
			if(!str) return str;
			
			var r = str, eArr = settings.entity;
			
			var StringToEntity = function(){
				EntityToString();
				for(var i in eArr){
					r = r.replace(eArr[i][0], eArr[i][1][0], 'ig');
				}
			};
			var EntityToString = function(){
				for(var i in eArr){
					var re = new RegExp(eArr[i][1].join('|'), 'ig');
					r = r.replace(re, eArr[i][0]);
				}
				r = r.replace(/[ ]+/g, ' ');
			};
			
			if('StringToEntity' == type){
				StringToEntity();
			}else{
				EntityToString();
			}
			return r;
		}
		
		/* ***********************************
		 * イベント
		 */
		,"_event": function(){
			
			$(window).resize(function(){
				__self._windowSizing();
			});
			
			$('#result').on('click', 'h3 a', function(){
				if(!window.opener || window.opener.closed){
					//親ウィンドウが存在しない
					$(this).attr('target','parent');
					//return false;
				}else{
					//window.openerで親ウィンドウのオブジェクトを操作
					window.opener.location.href = $(this).attr('href');
					return false;
				}
			});
			
			$('#searchBtn').on("click", function(){
				$('form#search').submit();
			});
			$('form#search').submit(function(){
				var str = $.trim($('#searchKey').val());
				if(str=="") return false;
				
				var fil = '', op = [];
				$('fieldset.option input:checked').each(function(){
					op[op.length]=$(this).val();
				});
				if(op) fil += '&op=' + op.join(',');
				window.location =  settings.searchURI +"?k="+encodeURIComponent(str) + fil;
				return false;
			});
			
			var movPage = function(p){
				if(/^\d+$/.test(p)){
					__self._pagenavi(serchRe, p);
					__self._view(serchRe, p);
				}else{
					return false;
				}
			};
			$('#navi').on('click', 'span:not(.disable)', function(){
				if($(this).is('.prev')){
					movPage( $(this).nextAll('.selected').text() -1 );
				}else if($(this).is('.next')){
					movPage( $(this).prevAll('.selected').text()-0 +1 );
				}else if($(this).is('.first')){
					movPage(1);
				}else if($(this).is('.last')){
					__self._view(serchRe, __self._pagenavi(serchRe, "last"));
				}else{
					movPage( $(this).text() );
				}
				$(this).blur();
				$('#result').scrollTop(0);
			});
		}
		
		
		/* ***********************************
		 * オートコンプリート
		 */
		,"_autocomplete": function(elm){
			$(elm).autocomplete({
				delay: 500,
				source: function( request, response ){
					var re = new RegExp( '^' + $.ui.autocomplete.escapeRegex( request.term ), "i" );
					response( $.grep( availableTags, function( value ){
						value = value.label || value.value || value;
						return re.test( value );
						})
					);
				}
			});
		}
		
		
		/* ***********************************
		 * ユーザーフォント削除
		 */
		,"_ufrm": function(data){
			return data.replace(/(@@@)((\d@)+)(@@)/g, '');
		}
		
		
		/* ***********************************
		 * 検索キー作成
		 */
		,"_createFindReg": function(v){
			var findregs = [];
			v = v.replace(/\s|[　]+/g," ");
			
			var escapeRegex = function(s){
				return s.replace(/[-[\]{}()*+?.,\\^$|#]/g, "\\$&");
			};
			
			if( !settings.ZenHan && /[\!-\~！-～￥]/.test(v) ){
				v=v.split('');
				for(var i=0,len=v.length; i<len; i++){
					v[i] = v[i].replace(/[\!-\~！-～￥]/, function(s){
						if(/[！-～]/.test(s)){
							return '(' + s + '|' + escapeRegex(String.fromCharCode(s.charCodeAt(0) - 0xFEE0)) + ')';
						}else if(/[￥]/.test(s)){
							return '(' + s + '|' + escapeRegex(String.fromCharCode(0x005C)) + ')';
						}else if(/[\\]/.test(s)){
							return '(' + escapeRegex(s) + '|' + String.fromCharCode(0xFFE5) + ')';
						}else{
							return '(' + escapeRegex(s) + '|' + String.fromCharCode(s.charCodeAt(0) + 0xFEE0) + ')';
						}
					});
				}
				v=v.join('');
			}else{
				v=escapeRegex(v);
			}
			
			var key = v.split(" ");
			
			for(var i=0,len=key.length; i<len; i++){
				if(key[i]==""){key.splice(i,1);}
			}
			for(var i=0,len=key.length; i<len; i++){
				var findreg = [];
				try{
					findreg[findreg.length]=new RegExp("(" + key[i] + ")", settings.charUpLo);
				}catch(e){
					
				}
				findregs[findregs.length]=findreg;
			}
			
			//関連キーワード作成
			__self._releateQuery(key);
			
			return findregs;
		}
		
		
		/* ***********************************
		 * ソート
		 */
		,"_regSort": function(a, b){
			return (a.source.length < b.source.length) ? 1 : -1;
		}
		
		
		/* ***********************************
		 * findregからor検索Reg作成 （現在は無意味）
		 */
		,"_createBoldReg": function(findreg){
			var strreg = [], tmpreg = '';
			for(i=0,len=findreg.length; i<len; i++){
				tmpreg = findreg[i].source;
				tmpreg = tmpreg.substring(1,tmpreg.length-1);
				strreg.push(tmpreg);
			}
			strreg = "(" + strreg.join('|') + ")";
			
			var boldreg = new RegExp(strreg, settings.charUpLo);
			return boldreg;
		}
		
		
		/* ***********************************
		 * 関連キーワード作成
		 */
		,"_releateQuery": function(keys){
			for(var i in keys){
				var a = keys[i].toLowerCase();
				for(var j in settings.keywordData){
					var b = j.toLowerCase();
					if(a == b){
						settings.releatekey = settings.releatekey.concat(settings.keywordData[j]);
					}
				}
			}
		}
		
		
		/* ***********************************
		 * 検索処理
		 */
		,"_find": function(query){
			
			if(!query) return [];
			
			//検索キー作成 /(aaa)/i,/(bbb)/i
			var findRegs = __self._createFindReg(query);
			
			var result = [];
			//重複さけるための配列
			var idList= [];
			
			for(var h=0,len1=findRegs.length; h<len1; h++){
				var findreg = findRegs[h];
				var boldreg = __self._createBoldReg(findreg);
				var res = false;
				var tHit = false;
				
				if(settings.andSearch && h>0){
					var result2=[];
					for(var i=0,len2=result.length; i<len2; i++){
						res = false;
						tHit = false;
						for(j=0,len3=findreg.length; j<len3; j++){
							tHit = result[i][0] || findreg[j].test(settings.datalistTit[result[i][1]]);
							res = findreg[j].test(settings.datalist[result[i][1]]);
							if(!res){break;}
						}
						if(res){
							if($.inArray(boldreg, settings.bolderlist) == -1) settings.bolderlist.push(boldreg);
							result2.push([tHit,result[i][1]]);
						}
					}
				}else{
					for(var i=0,len2=settings.datalist.length; i<len2; i++){
						res = false;
						tHit = false;
						s = settings.datalist[i];
						if($.inArray(i,idList)==-1){
							for(var j=0,len3=findreg.length; j<len3; j++){
								tHit = tHit || findreg[j].test(settings.datalistTit[i]);
								res = findreg[j].test(s);
								if(!res){break;}
							}
							if(res){
								idList[idList.length]=i;
								if($.inArray(boldreg, settings.bolderlist) == -1) settings.bolderlist.push(boldreg);
								result.push([tHit,i]);
							}
						}
					}
				}
				result = (result2) ? result2 : result ;
			}
			
			var r1=[],r2=[];
			for(var i=0,len=result.length; i<len; i++){
				if(result[i][0]){//tHit true
					r1[r1.length]=result[i][1];
				}else{
					r2[r2.length]=result[i][1];
				}
			}
			var result = r1.concat(r2);
			
			return result;
		}
		
		
		/* ***********************************
		 * 検索結果を表示
		 */
		,"_view": function(result, page){
			var offset = page || 1;
			var totalHit = result.length;
			var buf = [], count = 0;
			
			for(var i=(offset-1)*settings.maxItemOfPage; i<totalHit; i++){
				count++;
				if(count > settings.maxItemOfPage) break;
				var da = settings.index[result[i]];
				var title = __self._entityReplace( da.Title );
				var body = __self._entityReplace( da.Body );
				
				//トリミング
				var snippetRe = __self._snippet(body, settings.bolderlist);
				body = snippetRe.body;
				
				//ハイライト
				body = __self._boldKeyword(body, settings.bolderlist);
				title = __self._boldKeyword(title, settings.bolderlist);
				
				buf.push(
					'<div class="item">'
					,'<h3><a href="', da.File ,'">', title || txt.searchUnknoun ,'</a></h3>'
					,'<p>', snippetRe.start + body + snippetRe.end ,'</p>'
					//,'<div class="path">', da.Path ,'</div>
					,'</div>'
				);
			}
			
			if(settings.releatekey.length){
				$('#relatedWords').remove();
				temp = '<div id="relatedWords"><h4>'+ txt.searchRelatedHeader +'</h4>';
				for(var i=0, len=settings.releatekey.length; i<len; i++){
					var fil = (get["op"]) ? '&op=' + get["op"] : '';
					relatedUrl = settings.searchURI + "?k=" + encodeURIComponent(settings.releatekey[i]) + fil;
					temp += '<span class="relatedKey"><a href="' + relatedUrl + '">' + settings.releatekey[i] + '</a></span>';
				}
				temp += '</div>';
				buf.unshift(temp);
			}
			/*
			var cost = Math.min(fi+1, totalHit);
			var coen = Math.min(fi+settings.maxItemOfPage, totalHit);
			var entry = "[ "+ cost +" - "+ coen +" / "+ totalHit +" ]";
			var end = new Date().getTime();
			searchTime = (end - settings.startTime) / 1000;
			*/
			var srCount = '';
			if(settings.srCountType == 1){
				srCount = '<span>' + totalHit + '</span><span>'+ txt.searchCounts1 +'</span>';
			}else{
				srCount = '<span>' + totalHit + '</span><span>'+ txt.searchCounts1 +'</span>';
			}
			
			$('#' + settings.st).html(function(){
				return (totalHit == 1) ? srCount.replace('items', 'item') : srCount ;
			});
			
			$('#' + settings.re).html(function(){
				return buf.join("") || txt.msg10;
			});
			$('html,body').scrollTop(0);
		}
		
		
		/* ***********************************
		 * 説明トリミング
		 */
		,"_snippet": function(body, boldreg){
			var sniPoint = 0, isMatch = false;
			for(i=0,len=boldreg.length; i<len; i++){
				var re = new RegExp(boldreg[i].source, settings.charUpLo);
				isMatch = body.match(re);
				if(isMatch) break;
			}
			if(isMatch) sniPoint = Math.max(sniPoint, isMatch.index);
			
			var sb = sniPoint - settings.snippetStart;
			var eb = sniPoint + settings.snippetStart + settings.snippetLength;
			var rb = body.substring(sb, eb);
			
			var start = (sb > 0) ? settings.omi : "";
			var end = (body.length > eb) ? settings.omi : "";
			
			return {"body": rb, "start": start, "end": end};
		}
		
		
		/* ***********************************
		 * キーワードの強調処理
		 */
		,"_boldKeyword": function(body, boldregs, boolFalse){
			var result = __self._entityReplace(body, 'StringToEntity');
			
			if(boolFalse !== false){
				var strreg = [], tmpreg = '';
				for(i=0,len=boldregs.length; i<len; i++){
					tmpreg = boldregs[i].source;
					tmpreg = tmpreg.substring(1,tmpreg.length-1);
					strreg.push(tmpreg);
				}
				strreg = "(" + strreg.join('|') + ")";
				strreg = __self._entityReplace(strreg, 'StringToEntity');
				
				var boldreg = new RegExp(strreg, settings.charUpLo +'gm');
				if(!/^(\d|\d(@\d)+)$/.test(result)){
					result = result.replace(boldreg, '<span class="hitkey">$1</span>');
				}
			}
			return result;
		}
		
		
		/* ***********************************
		 * ページナビ作成
		 */
		,"_pagenavi": function(result, p){
			var buf = [];
			var bufF = $('<div><span class="marg first">&nbsp;</span><span class="marg prev">&nbsp;</span></div>');
			var bufR = $('<div><span class="marg next">&nbsp;</span><span class="marg last">&nbsp;</span></div>');
			var pageCount = Math.ceil(result.length / settings.maxItemOfPage);
			settings.page = (p === 'last')? pageCount :  p || settings.page;
			
			var i=1;
			if(settings.pageNaviMax < pageCount){
				if(settings.page == 1){//先頭
					bufF.find('span').addClass('disable');
					//bufR = bufR;
				}else if(settings.page == pageCount){//最後
					i = pageCount - settings.pageNaviMax+1;
					//bufF = bufF;
					bufR.find('span').addClass('disable');
				}else{
					i = settings.page - ( Math.floor(settings.pageNaviMax / 2) );
					if( pageCount - i < settings.pageNaviMax -1){
						i = i - ((settings.pageNaviMax -1) - (pageCount - i));
					}
					//bufF = bufF;
					//bufR = bufR;
				}
			}else{
				bufF.find('span').addClass('hide');
				bufR = $('');
			}
			bufF = bufF.html()||"";
			bufR = bufR.html()||"";
			
			i = (i<1)?1:i;
			var loop = Math.min(pageCount, i + settings.pageNaviMax - 1);
			while(i<=loop){
				if(i == settings.page){
					buf.push('<span class="selected">'+i+'</span>');
				}else{
					buf.push('<span>'+i+'</span>');
				}
				i++;
			}
			$('#navi').html(bufF + buf.join("") + bufR);
			
			if(p === 'last') return pageCount;
		}
		
		
		/* ***********************************
		 * サイジング
		 */
		,"_windowSizing": function(){
			$('#searchKey').width(function(){
				var r = $(window).width() -2
					- margeWH('#searchKey','w') - $('#searchBtn').outerWidth(true)
					- margeWH('#container>fieldset','w') - margeWH('#container','w')
					- margeWH('#search','w') - margeWH('#contents','w')
					- margeWH('#body','w') - margeWH('body','w');
				return r;
			});
			$('#result').height(function(){
				var r = $(window).height() -5
					- margeWH('#result','h') - $('fieldset.option').outerHeight(true)
					- margeWH('#section','h') - $('#container>fieldset').outerHeight(true)
					- margeWH('#container','h') - $('#navigation').outerHeight(true)
					- margeWH('#search','h') - margeWH('#contents','h')
					- margeWH('#body','h') - margeWH('body','h');
				return r;
			});
		}
		
	};
	
	return {
		"init": __self._init
		//,"settings": settings
	};
}());


$(function(){
	
	Searching.init();
	
});

