// 45822035EE_02
// ---------------------
/*/////////////////////////////////////////////////////////////////////////////////////////////////
	User Guide 
		Function JavaScript
 Modified : 2014-07-31
/////////////////////////////////////////////////////////////////////////////////////////////////*/


	// プロトコルを見て検索のフォーム action値を html＞phpへ------
	function searchAction(formAction){
		var searchAction = (!NotHTTP)? formAction.replace(/\.htm.?$/,".php") : formAction ;
		return searchAction;
	}
	// ---------------------------------------------------------
	
	
	//アウターサイズからインナーサイズを引いた値（余白）----
	function margeWH(ele, wh){
		var temp = 0;
		if(wh == "w"){
			temp = $(ele).outerWidth(true) - $(ele).width();
		}else{
			temp = $(ele).outerHeight(true) - $(ele).height();
		}
		return (temp||0);
	}
	// ---------------------------------------------------------
	
	
	//PXをEMで返す  ------------------------------------------
	function pxToEm(t,wh,num){//t=target; wh=(w:width | h:height); num=[size]
		var temp=0,w;
		var f = $(t).css('fontSize').replace('px','') *1;
		if(wh == "w"){
			w = num||$(t).width();
			temp = (w / f) + 'em';
		}else{
			w = num||$(t).height();
			temp = (w / f) + 'em';
		}
		return (temp||0);
	}
	// ---------------------------------------------------------
	
	
	//CSSの値からPXを消して数値として返す  ------------------------------------------
	function delPx(n){
		if(/px\s*$/i.test(n)){
			var n = n.replace(/(px|\s)/gi, '')*1;
		}
		if(n == void(0)) n = 0;
		return n;
	}
	// ---------------------------------------------------------
	
	
	// 配列の重複削除  ------------------------------------------
	function uniqueArray(array){
		var storage = {};
		var uniqueArray = [];
		var i,value;
		for ( i=0; i<array.length; i++){
			value = array[i];
			if (!(value in storage)){
				storage[value] = true;
				uniqueArray.push(value);
			}
		}
		return uniqueArray;
	}
	// ---------------------------------------------------------
	
	
	// 以下、要JQuery ************************************************************
	
	// Naviの有無 ---------------------------------------------
	function isCategoryNavi(){
		return $('#contents').is(':has(#categoryNavi)');
	}
	// ---------------------------------------------------------
	
	
	// Naviの有無 ---------------------------------------------
	function isNavi(){
		return $('#contents').is(':has(#Navi)');
	}
	// ---------------------------------------------------------
	
	
	// 検索フォーム --------------------------------------------
	function searchFormFunc(){
		if(!$('#searchKey').val()){
			$('#searchKey').val(txt.searchKeyDef);
		}
		$('#searchKey')
			.after(
				'<span id="searchBtn" title="'+txt.search+'">'
				//+'<span class="outerCommon"><img src="'+jsCPath+'local/'+lang+'/img/common_'+settings.language+'.png" class="commonImage"></span>'
				+'</span>')
			.focus(function(){
				if($(this).val() == txt.searchKeyDef){
					$(this).val('').addClass("keyIn");
				}else{
					$(this).addClass("keyIn");
				}
			})
			.blur(function(){
				$('#searchKey').val($(this).val().replace(/^\s+/, '').replace(/\s+$/,'').replace(/[　\s]+/g,' '));
				if(!$(this).val()){
					$('#searchKey').val(txt.searchKeyDef).removeClass("keyIn");
				}
			})
			.autocomplete({
				delay: 500,
				appendTo: '#search',
				source: function( request, response ){
					var re = new RegExp( '^' + $.ui.autocomplete.escapeRegex( request.term ), "i" );
					response( $.grep( availableTags, function( value ){
						value = value.label || value.value || value;
						return re.test( value );
						})
					);
				}
			});
		$('#searchBtn').click(function(){ $('form#search').submit(); });
		$('form#search').submit(function(){
			var str = $('#searchKey').val();
			if((str==txt.searchKeyDef)||str==""){
				return false;
			}else{
				searchWin = window.open(
					$('form#search').attr('action') +"?k="+encodeURIComponent($('#searchKey').val()),
					"searchWin",
					"width=320,height=650,resizable=yes,scrollbars=yes"
				);
				searchWin.focus();
				return false;
			}
		});
	}
	// ---------------------------------------------------------
	
	
	// 印刷イベント --------------------------------------------
	function printEvent(){
		$('#thisPrint').on('click', function(){ print(); });
		$('#selectPrint').on('click', function(){
			selePrint = window.open("contents/selected_print.html", "selected_print", "width=860,height=500,resizable=yes,scrollbars=yes");
			selePrint.focus();
		});
	}
	// ---------------------------------------------------------
	
	
	//アラートWin -----------------------------------------------
	function alertWin(title, text, autoClose){
		$("body").append('<div id="alertWin">'+text+'</div>');
		var modalType;
		if(autoClose){
			modalType = false;
		}else{
			$('#alertWin').append('<div class="btn"><button value="yes">'+ txt.ok +'</button></div>');
			modalType = true;
		}
		$('#alertWin button').button();
		$('#alertWin').dialog({
			dialogClass: "modalWin",
			title: title,
			modal: modalType,
			resizable: false,
			draggable: false,
			closeOnEscape: false,
			open: function(event, ui){
				setTimeout(function(){$('.ui-state-focus').removeClass('ui-state-focus');},0);
				if(autoClose){
					setTimeout(
						function(){
							$('#alertWin').dialog('destroy').remove();
						}, autoClose
					);
				}
			},
			close: function(event, ui){
				$('#alertWin').dialog('destroy').remove();
			}
		});
		$('#alertWin').on('click', 'button', function(){
			switch($(this).val()){
				case "yes":
				default:
					$('#alertWin').dialog('destroy').remove();
					break;
			}
		});
		$('.modalWin button').attr('hideFocus','true');
	}
	// ---------------------------------------------------------
	
	
	//サイジング ------------------------------------------------
	function resizeAdj(){
		var winW = $(window).width();
		var winH = $(window).height();
		var ct, cb, temp;
		if(!isTop){
			if(ua._isIE7||ua._isIE6){
			 	ct = cb = 0;
			 }else{
			 	ct = delPx($('#header').css('top')) ;
			 	cb = delPx($('#footer').css('bottom'));
			}
			
			$('#contents').css('marginTop', $('#header').outerHeight(true) + ct +'px');
			if($('#modalWin>div').is('#favoriteEditWin')){
				$('#favoriteEditWin').height($('#favorite').height());
				$('#modalShadow').height(winH).width(winW);
			}
			
			
			temp = winH - $('#footer').outerHeight(true) - cb - $('#header').outerHeight(true) - ct;
			//$('#container').height( temp );//- margeWH('#container', 'h') );
			$("#container").css("minHeight", temp - ( delPx($("#container").css("paddingTop")) + delPx($("#container").css("paddingBottom")) ));
			
			$('#contentsBoderBottom').css('marginTop', (temp - (
					delPx($("#container").css("paddingTop"))
					+ delPx($("#container").css("marginTop"))
					+ delPx($("#container").css("borderTopWidth"))
					+ delPx($('#contentsBoderTop').css('borderTopWidth'))
				)) +'px');
			
			var cm = margeWH('#categoryNavi', 'h');
			$('#categoryNavi').height( temp - cm ).css('top', ($('#header').outerHeight(true) + $('#header').position().top) +'px');
			
			if(isNavi()){
				temp -= $('#Navi .ui-tabs-nav').outerHeight(true) + $('#Navi .ope').outerHeight(true) + cm ;
				temp -= margeWH('#localMenu .list', 'h');
				$('#Navi .ui-tabs-panel .list').height(temp);
			}
			
			//$('#page').height( $('#container').height() - $('#container h1').outerHeight(true) - margeWH('#page', 'h') );
		}
		temp = winW - margeWH('#container', 'w');
		if((!isTop)&&(temp > delPx($('#container').css('minWidth')))){
			if(temp < delPx($('#container').css('maxWidth'))){
				$('#container').width(temp);
			}else{
				$('#container').width(delPx($('#container').css('maxWidth')));
			}
		}
		$('#contentsBoderTop, #contentsBoderBottom').width($('#container').outerWidth());
		if(ua._isIE7||ua._isIE6) setTimeout(function(){$('body').removeAttr('style');},0);
	}
	// ---------------------------------------------------------
	
	
	//カテゴリトップのリンク -----------------------------------
	function categoryFirstLink(id){
		if (menu[id].titlelink) {
			return menu[id].titlelink;
		}else{
			var m = $(menu[id].menu);
			return m.find('span:has(>a):first').html();
		}
	}
	// ---------------------------------------------------------
	
	
	// アンカー、ボタンの選択枠消し ----------------------------
	function hideFocus(){
		$('a, button').attr('hideFocus','true');
	}
	// ---------------------------------------------------------
	
	
	//クッキー確認 ---------------------------------------------
	function cookieCkeck(){
		$.cookie("test", "1");
		var r;
		if($.cookie("test") === "1"){
			r = true;
		}else{
			r = false;
		}
		$.removeCookie("test");
		return r;
	}
	// ---------------------------------------------------------
	
	
	//クッキー or WebStrage 読み込み＆保存----------------------
	function localSpace(cmd, key, val, option){
		if(!option) option = {};
		
		var op = {};
		op.expires = option.expires || 365;
		if(ua._isIE) option.path = '/';
		if(option.path) op.path = option.path;
		if(option.domain) op.domain = option.domain;
		if(option.secure) op.secure = option.secure;
		
		key = (settings.cookieKey) ? key +'-'+  settings.cookieKey : key;
		
		if(_isWebStrg){
			var Storage = (option.session) ? sessionStorage : localStorage;
			if("save" === cmd){
				try{
					Storage.setItem(key, val);
				}catch(domException){
					if(domException.name === 'QuotaExceededError' || domException.name === 'NS_ERROR_DOM_QUOTA_REACHED'){
						// Fallback code comes here.
					}
				}
			}else if("load" === cmd){
				return Storage.getItem(key);
			}else if("remove" === cmd){
				Storage.removeItem(key);
			}
		}else{
			if("save" === cmd){
				$.cookie(key, val, op);
			}else if("load" === cmd){
				return $.cookie(key);
			}else if("remove" === cmd){
				$.removeCookie(key, op);
			}
		}
	}
	// ---------------------------------------------------------
	
	
	
	